import { Db, Collection } from 'mongodb';
import MongoEntity from './mongo_entity';
export interface ITestingOptions {
    mongoHost?: string;
    mongoPort?: string;
    mongoDisposeTimeout?: number;
    initContext?: (conn: any) => any;
}
export declare function config({mongoHost, mongoPort, mongoDisposeTimeout, initContext: ic}: ITestingOptions): void;
export declare function getDb(): Promise<Db>;
export interface TestOption<T> {
    data?: T[];
    name?: string;
    type?: any;
    entity?: MongoEntity<T>;
}
export interface TestOptions {
    entities?: TestOption<any>[];
}
export declare function withEntity(test: (...entity: any[]) => any, options?: TestOptions): Promise<any>;
export declare function itWithEntity(name: string, func: (...entity: any[]) => any, options?: TestOptions): void;
export declare function withContext(test: (context: any) => any, initContextFn?: (conn: any) => any, disconnected?: boolean): Promise<any>;
export declare function itWithContext(name: string, func: (context: any) => void, initContextFn?: (conn: any) => any, disconnected?: boolean): void;
export declare function getConnector(): Promise<{
    collection(name: string): Collection<{}>;
}>;
export declare function disposeDb(immediate?: boolean): void;
